program bandlist

  ! Хɤˤbsub-subtractedꥹȤʬ
  !  Written by H. Shimizu  2007-10-18

  character (len=80) :: line, fname, pname, lflat, lobj, lff, chgrtfn
  character (len=30) :: bsub, filter, suf, flat, key, filter01, toupper
  character (len=20) :: band(10)
  integer :: iarg, lenf, leng
  
  iarg=iargc()          ! ޥɥ饤ο(ץ̾)
  call getarg(0,pname)  ! ¹Ԥץ̾
  len=len_trim(pname)     ! ץ̾ʸ
  if ( iarg<6 ) then    ! ޥɥ饤˰ʤ...
     print *,'Number of arguments is not sufficient'
     print *, 'usage: ', pname(:len), ' bslist filter-key flat-key ', &
          &   'flat-list object-list ff-list'    ! ˡ
     print *, '        bslist     : list of bias-subtracted frames'
     print *, '        filter-key : FITS keyword for filters'
     print *, '        flat-key   : FITS keyword for flat'
     print *, '        flat-list  : list of flat field frames'
     print *, '        object-list: list of object frames '
     print *, '        ff-list    : list of flat-fielded frames'
     stop 
  end if
  
  call getarg(1,bsub)  ! ޥɥ饤ΰ
  call getarg(2,filter)
  call getarg(3,flat)
  call getarg(4,lflat)
  call getarg(5,lobj)
  call getarg(6,lff)
  
  open(11, file=bsub)
  
  filter=toupper(filter)
  lenf=len_trim(filter)
  nb=0
  k1=20
  k2=30
  k3=40
  nf=0
  do i=1, 999
     read(11,*,end=999) fname
     nf=nf+1
     leng=len_trim(fname)
     open(12, file=fname, access='direct', recl=80, form='formatted')
     j=0
     line=' '
     do while (line(1:3)/='END')
        j=j+1
        read(12, '(a80)', rec=j) line
        if ( line(1:lenf)==filter ) then
           if ( nb==0 ) then
              nb=nb+1
              idum = index(line(12:31),char(39))
              band(nb) = line(12:idum+10)
           else 
              isame=0
              idum = index(line(12:31),char(39))
              do k=1, nb
                 if ( line(12:idum+10)==band(k)(1:idum-1) ) isame=1
              end do
              if ( isame/=1 ) then
                 nb=nb+1
                 idum = index(line(12:31),char(39))
                 band(nb) = line(12:idum+10)
              end if
           end if
        end if
     end do
     close(12)
  end do
999 rewind(11)    ! rewind bsub.list
  do i=1, nb
     print *, i, band(i)
  end do

  do i=1, nb   ! open OUTPUT files
     suf=band(i)(:len_trim(band(i)))//'.list'
     fname=lflat(:len_trim(lflat))//suf
     open(k1+i, file=fname)
     fname=lobj(:len_trim(lobj))//suf
     open(k2+i, file=fname)
     fname=lff(:len_trim(lff))//suf
     open(k3+i, file=fname)
  end do

  do i=1,nf    ! repeat for files in bsub.list
     iflat=0
     read(11,*) fname
     leng=len_trim(fname)
     open(12, file=fname, access='direct', recl=80, form='formatted')
     j=0
     line=' '
     do while (line(1:3)/='END')
        j=j+1
        read(12, '(a80)', rec=j) line
        if ( line(1:8)=='OBJECT  ' ) then
           key = line(12:31)
           idam = index(key, char(39))
           key(idam:idam)=' '
        else if ( line(1:8)==filter ) then
           read(line(12:31),'(a)') filter01
           idam = index(filter01, char(39))
           filter01(idam:idam)=' '
        end if
     end do
     key=toupper(key)
     if ( index(key, flat(:len_trim(flat))) /= 0 ) iflat=1
     if ( iflat==1 ) then
        do j=1, nb 
           if ( index(filter01,band(j))/=0 ) then
              write (k1+j, *) fname(:leng)
              print *, '  ',fname(:30), 'FLAT_'//band(j)(:10) ! for test
           end if
        end do
     else
        do j=1, nb 
           if ( index(filter01, band(j))/=0  ) then
              write (k2+j,*) fname(:leng)
              print *, '  ', fname(:30), 'OBJECT_'//band(j)(:10) ! for test
              fname=chgrtfn(fname, 'bs', 'ff')
              write (k3+j, *) fname(:leng)
              print *, '  ', fname(:30), 'OBJECT_ff'//band(j)(:10) ! for test
           end if
        end do
     end if
     close(12)
  end do

  do i=1, nb
     close(k1+i)
     close(k2+i)
     close(k3+i)
  end do

end program bandlist

