#
#
procedure  smooth (oldimages, newimages)

file	oldimages	{prompt='Input  images'}
file	newimages	{prompt='Output images'}
int	offset		{1,prompt='IRAF file number offset'}

struct  *oldlist, *newlist

begin
	file	oldimage,  newimage,  newhead
	file	temp1, temp2
	int	oldcount,  newcount,  seqno

# --- Expand metacharacters (or @-files) in each input parameter 
#     into a template file.
	temp1 = mktemp ("smooth.tmp")
	files (oldimages, > temp1)
	oldlist = temp1
	temp2 = mktemp ("smooth.tmp")
	files (newimages, > temp2)
	newlist = temp2

# --- Count specified old and new images.
	oldcount  = 0
	while (fscan (oldlist,  oldimage ) != EOF) {
	    oldcount  += 1
	}
	oldlist  = temp1	# rewind oldlist
	newcount = 0
	while (fscan (newlist, newimage) != EOF) {
	    newcount += 1
	}
	newlist = temp2		# rewind newlist

# --- Main
	task $smooth1 = ("$" // osfn("spiral$bin/") // "smooth.e $(1) $(2)" )
	if (newcount == oldcount) {
	    while (fscan (oldlist, oldimage) !=EOF && \
	    	   fscan (newlist, newimage) !=EOF    ) {
	       print ("smooth "//oldimage//" --->  "//newimage)
	       smooth1 (oldimage, newimage)
	    }
	}
	else if (newcount == 1) {
	    newhead = newimage
	    seqno = offset
	    while (fscan (oldlist,  oldimage ) != EOF) {
	        seqno += 1
	        newimage = newhead // "000" + seqno
	        print ("smooth "//oldimage//" --->  "//newimage)
	        smooth1 (oldimage, newimage)
	    }
	}
	else print ("Error: The numbers of oldimage and newimage are not the same.")

	oldlist = ""
	newlist = ""
	del ("smooth.tmp*", verify-, >& "dev$null")
end
