#
#	unitmag.cl
#
#	last update: 1994-08-16 by M. Hamabe
#	last update: 1995-06-30 by M. Hamabe
#

procedure  unitmag (image,xc,yc,color)

file	image		{prompt='input image'}

real    xc		{0.0,prompt='x-coordinate of galaxy center (in pixel)'}
real    yc		{0.0,prompt='y-coordinate of galaxy center (in pixel)'}
bool    catalog         {yes,prompt='use UBV-mag. catalog by Longo et al.?'}
char	color		{'v',prompt='color for Longo-catalog (u/b/v)'}
bool    range           {no,prompt='set rejection aperture range?'}
bool    scale           {yes,prompt='auto-scaling?'}
char	device		{'xserv',prompt='plotting device (tek/xwin/xserv/inq)'}
bool    hardcopy        {no,prompt='make a hardcopy?'}
char    hdev            {'ps',prompt='hardcopy device (ps/lips)'}
char    hfile           {'unitmag.ps',prompt='hardcopy-file name'}
bool    id              {yes,prompt='plot ID on the hardcopy?'}

begin

	task $unitmag1=("$" // osfn("spiral$bin/") // "unitmag.e $(*)" )
	   unitmag1 (image,xc,yc,catalog,color,range,scale,device,hardcopy,hdev,hfile,id)

end
